$logFile="C:\medent\MEDENTCloudConnectionTest.log"
$MMconnection_error="N"
$MCconnection_error="N"

$OriginalProgressPreference = $Global:ProgressPreference
$Global:ProgressPreference = 'SilentlyContinue'
$host.UI.RawUI.BackgroundColor = "Black"

Write-Host "Phase 1: " -ForegroundColor blue -NoNewLine
Write-Host "Testing connection to https://medentmobile.com ..."
$connectionTest = (Test-NetConnection -ComputerName medentmobile.com -Port 443 -ErrorAction Stop)
if ($connectionTest.TcpTestSucceeded -ceq "True")
{
  if ($connectionTest.RemoteAddress -eq "65.114.41.8")
  {
    Write-Host "The remote address is correct (65.114.41.8) - DNS + redirect test PASSED!" -ForegroundColor green
    Write-Host
	Write-Host "Checking certificate for https://medentmobile.com ..."
    $MMwebRequest = [Net.WebRequest]::Create("https://medentcloud.com")
    try { $MMwebRequest.GetResponse() } catch {}
    $MMcertIssuer = $MMwebRequest.ServicePoint.Certificate.Issuer
    if ($MMcertIssuer -ilike "*Network Solutions*") 
	{
	  Write-Host "Certificate issuer is correct (Network Solutions) - SSL Inspection test PASSED!" -ForegroundColor green
	}
	else
	{
	  Write-Host "WARNING! Certificate issuer is NOT Network Solutions - certificate check FAILED!" -ForegroundColor red
      Write-Host "The issuer is:" $MMcertIssuer
      Write-Host
      Write-Host "This indicates that SSL Inspection is happening on this connection."
      Write-Host "The MEDENT Client's IT must exclude medentmobile.com from this inspection."
    }	  
  }
  else
  {
	  if ($connectionTest.RemoteAddress -eq $null)
	  {
	    Write-Host "RemoteAddress is empty, the connection attempt to https://medentmobile.com FAILED!" -ForegroundColor red
		$MMconnection_error="Y"
	  }
	  else
	  {
		  Write-Host "WARNING! The remote address is NOT the expected IP address of 65.114.41.8 - DNS + redirect test FAILED!" -ForegroundColor red
		  Write-Host "This likely means that the connection attempt to https://medentmobile.com was redirected to a block page."
		  Write-Host
		  Write-Host "The IP address the connection went to was:" $connectionTest.RemoteAddress
		  Write-Host
		  $MMconnection_error="Y"
	  }
  }
}
else
{
  Write-Host "WARNING! The connection attempt to https:/medentmobile.com FAILED!" -ForegroundColor red
  $MMconnection_error="Y"
}

$connectionTest=$null
Write-Host
Write-Host "Phase 2: " -ForegroundColor blue -NoNewLine
Write-Host "Testing connection to https://medentcloud.com ..."
$connectionTest = (Test-NetConnection -ComputerName medentcloud.com -Port 443 -ErrorAction Stop)
if ($connectionTest.TcpTestSucceeded -ceq "True")
{
  if ($connectionTest.RemoteAddress -eq "65.114.41.50")
  {
    Write-Host "The remote address is correct (65.114.41.50) - DNS + redirect test PASSED!" -ForegroundColor green
    Write-Host
	Write-Host "Checking certificate for https://medentcloud.com ..."
    $MCwebRequest = [Net.WebRequest]::Create("https://medentcloud.com")
    try { $MCwebRequest.GetResponse() } catch {}
    $MCcertIssuer = $MCwebRequest.ServicePoint.Certificate.Issuer
    if ($MCcertIssuer -ilike "*Network Solutions*") 
	{
	  Write-Host "Certificate issuer is correct (Network Solutions) - SSL Inspection test PASSED!" -ForegroundColor green
	}
	else
	{
	  Write-Host "WARNING! Certificate issuer is NOT Network Solutions - certificate check FAILED!" -ForegroundColor red
      Write-Host "The issuer is:" $MCcertIssuer
      Write-Host
      Write-Host "This indicates that SSL Inspection is happening on this connection."
      Write-Host "The MEDENT Client's IT must exclude medentcloud.com from this inspection."
    }	  
  }
  else
  {
	  if ($connectionTest.RemoteAddress -eq $null)
	  {
	    Write-Host "RemoteAddress is empty, the connection attempt to https://medentcloud.com FAILED!" -ForegroundColor red
		$MCconnection_error="Y"
	  }
	  else
	  {
		  Write-Host "WARNING! The remote address is NOT the expected IP address of 65.114.41.50 - DNS + redirect test FAILED!" -ForegroundColor red
		  Write-Host "This likely means that the connection attempt to https://medentcloud.com was redirected to a block page."
		  Write-Host
		  Write-Host "The IP address the connection went to was:" $connectionTest.RemoteAddress
		  Write-Host
		  $MCconnection_error="Y"
	  }
  }
}
else
{
  Write-Host "WARNING! The connection attempt to https:/medentcloud.com FAILED!" -ForegroundColor red
  $MCconnection_error="Y"
}

if ($MMconnection_error -eq "Y")
{
  Write-Host
  Write-Host "************************* ATTENTION! ************************* " -ForegroundColor red
  Write-Host "There was an error connecting to https://medentmobile.com !"
  Write-Host
  Write-Host "Please try to access that site in a web browser to see what you get, which"
  Write-Host "might be a message that it is blocked, or it might just timeout, or there"
  Write-Host "might be some other error displayed that points to the cause."
}

if ($MCconnection_error -eq "Y")
{
  Write-Host
  Write-Host "************************* ATTENTION! ************************* " -ForegroundColor red
  Write-Host "There was an error connecting to https://medentcloud.com !"
  Write-Host
  Write-Host "Please try to access that site in a web browser to see what you get, which"
  Write-Host "might be a message that it is blocked."
  Write-Host
  Write-Host "NOTE! It is expected that nothing will load at that site, it should just time out"
  Write-Host "and something similar to: This site can't be reached"
}

Write-Host
Write-Host "The MEDENT Cloud Connection Test has completed."
Write-Host
$Global:ProgressPreference = $OriginalProgressPreference
Write-Host "Press Enter to exit..."
do {
    $key = $Host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
    if ($key.VirtualKeyCode -eq 13) {
        exit 0
    }
} while ($true)
